/*                              ______________________________________
                               |                                      |
                    _.---------|.--.       PieGraph.js v1.0           |
                 .-'  `       .'/  ``   07/20/2005 - 17:40:48         |
              .-'           .' |    /|                                |
           .-'         |   /   `.__//     www.sobolewski.biz          |
        .-'           _.--/        /                                  |
       |        _  .-'   /        / e-mail: mariusz@sobolewski.biz    |
       |     ._  \      /     `  /                                    |
       |        ` .    /     `  /    © 2005 by Mariusz Sobolewski     |
       |         \ \ '/        /______________________________________|
       |        - \  /        /
       |        '  .'        /  edited: 2022 by Stephan Wissner / pixelstaub.köln
       |          '         |.' (added Support for actual InDesign Versions)
       |                    |  
       |                    |  
       |                    |.'
       |                    /
       |                   /
       |                  /
       )                 /|
    .▒/`-.              / |
   ▒▓▓▓▒. `-._         / /
  ▒▓▓▓▓▓▓▓▓▒. `-.     / /
 ▒▓▓▓▓▓▓▓▓▓▓▓▓▒. `.    /
▒▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒.`. /
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒.`.
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒.`.
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒.
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▒.
▓▓█░▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓
▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓▓█'

*/

// DEFINE YOUR PREFERENCES
var myStrokeColor = "Paper";
var myStrokeWeight = 0.5; // in points
// store actual scriptPreferences.version
var myActualScriptPreferencesVersion = app.scriptPreferences.version;
// set scriptPreferences.version to InDesign version 3 (compatibility reasons; otherwise script will throw error)
app.scriptPreferences.version = 3.0; 
var myFillColor = ["graphColor_1", // You can change the names of the colors here,
                   "graphColor_2", // but the actual color values need to be defined in your document.
                   "graphColor_3", // By default all colors will be set to C25 M25 Y25 K25,
                   "graphColor_4", // until you change them in your document!
                   "graphColor_5",
                   "graphColor_6",
                   "graphColor_7",
                   "graphColor_8",
                   "graphColor_9",
                   "graphColor_10"];

// var myParagraphStyle = "graphData"; // must be defined in the open document!

// ====================================================
// ====================================================

// Do NOT change anything below, unless you know what you are doing

if (app.locale == 1279479916){ // Polish
var txt_locale_1 = "Nie masz otwartych dokument\u00f3w!";
var txt_locale_2 = "Zaznacz ko\u0142o.";
var txt_locale_3 = "Zaznacz ko\u0142o.";
var txt_locale_4 = "Wykres ko\u0142owy";
var txt_locale_5 = "Ile warto\u015bci chcesz poda\u0107?:";
var txt_locale_6 = "Warto\u015b\u0107 ";
var txt_locale_7 = "Warto\u015bci obok wycink\u00f3w";
var txt_locale_8 = "Musisz zaznaczy\u0107 ko\u0142o.";
var txt_locale_9 = "Podane warto\u015bci nie sumuj\u0105 si\u0119 do 100\u0025. \nSprawd\u017a wpisywane warto\u015bci i spr\u00f3buj jeszcze raz.";
}
else { // Default to English
var txt_locale_1 = "No documents are open!";
var txt_locale_2 = "Select an oval.";
var txt_locale_3 = "Select an oval.";
var txt_locale_4 = "Pie Graph";
var txt_locale_5 = "Number of values you will enter";
var txt_locale_6 = "Value ";
var txt_locale_7 = "Values next to slices";
var txt_locale_8 = "The oval must be a circle!";
var txt_locale_9 = "The values you have entered do not add up to 100\u0025. \nPlease check your graph values and try again.";
}

// =========================================================================
        
// SAVE USERS MEASUREMENT PREFERENCES
var userHoriz = app.documents[0].viewPreferences.horizontalMeasurementUnits;
var userVert = app.documents[0].viewPreferences.verticalMeasurementUnits;

try{
        if (app.documents.length == 0){
		err(txt_locale_1);
	}
	if (app.documents.length != 0 && app.selection[0].constructor.name != "Oval"){
		err(txt_locale_2);
	}
	if (app.documents.length != 0 && app.selection[0].constructor.name == "Oval"){

        // set desired measurements
        app.documents[0].viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
        app.documents[0].viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
                        
                               
        // OVAL:
        var myCircle = app.selection[0];
        var myBounds = myCircle.geometricBounds;
        var myXcenter = Math.round( (myBounds[1] + ((myBounds[3] - myBounds[1]) / 2)) * 1000 ) / 1000; // round-off to 3 decimal places
        var myYcenter = Math.round( (myBounds[0] + ((myBounds[2] - myBounds[0]) / 2)) * 1000 ) / 1000;
        var myRadius = Math.round( ((myBounds[3] - myBounds[1]) / 2) * 1000 ) / 1000;

                if ((Math.round((myBounds[3] - myBounds[1]) * 1000) / 1000) != (Math.round((myBounds[2] - myBounds[0]) * 1000) / 1000)){
		err(txt_locale_8);
                }
	}
}

catch(e){
	err(txt_locale_3);
}


// =========================================================================

with (app)
{
	var myDlgBegin = dialogs.add({name:txt_locale_4,canCancel:true});
	with (myDlgBegin)
	{
		with (dialogColumns.add()) 
		{
			var myLabelA = staticTexts.add({staticLabel:txt_locale_5});
                        var mySpacer = staticTexts.add({staticLabel:"\u00A0"});
                        
                        var CopyrightA = staticTexts.add({staticLabel:"\u00A92022 Stephan Wissner (2005 Marius Sobolewski)"});
		}
		with (dialogColumns.add()) 
		{
			var myNumOfVals = realEditboxes.add({editValue:0});
                        var mySpacer = staticTexts.add({staticLabel:"\u00A0"});
                        
                        var CopyrightB = staticTexts.add({staticLabel:"\u00A0 www.pixelstaub.de"});
		}
	}
	resultBegin = myDlgBegin.show();
	if (resultBegin)
	{
		var myDlg = dialogs.add({name:txt_locale_4,canCancel:true});
		with (myDlg)
		{
			with (dialogColumns.add()) 
			{
                                var myLabel = new Array();
                                for (i = 0; i < myNumOfVals.editValue; i++) {
                                myLabel[i] = staticTexts.add({staticLabel:txt_locale_6 + (i +1)});
                                }
			}
			with (dialogColumns.add()) 
			{
                                var myValues = new Array();
                                for (i = 0; i < myNumOfVals.editValue; i++) {
                                myValues[i] = realEditboxes.add({editValue:0});
                                }
			}
		}
		graphInfo = myDlg.show();
                
                        // See if the values entered add up to 100%
                        var myValuesEntered = 0
                        for (i = 0; i < myValues.length; i++) {

                        myValuesEntered += myValues[i].editValue;
                        
                        }
                        if (myValuesEntered != 100) {
                                alert(txt_locale_9);
                        }
                        
		if (graphInfo == true && myValuesEntered == 100)
		{
                        var DtoR = Math.PI / 180; // Degrees to Radians converter

                        // Array of duplicated circles
                        var myNewCircles = new Array();
                                         
                        // Extra rotation required, if current slice is not the first one
                        var extraRotation = 0;
                        

                                for (i = 0; i < myValues.length; i++) {

                                var myAngleD = (myValues[i].editValue / 100) * 360; // in degrees
                                var myAngleR = myAngleD * DtoR; // in radians

                                // Make a copy of the selected circle
                                myNewCircles[i] = myCircle.duplicate();
                                
                                var sliceCounter = i;
                                if (sliceCounter >= myFillColor.length) {
                                sliceCounter = i % myFillColor.length; // reset the counter after reaching 10
                                }
                                
                                myDefineFillColor(myStrokeColor);
                                myDefineFillColor(myFillColor[sliceCounter]);
                               
                                        if (myAngleD <= 90) {
                                        // TRIANGLE:
                                        myHalfAngle = myAngleR / 2;

                                        var myPointA, myPointB, myPointC;

                                        // myPointA
                                        myPointA = new Array();
                                        myPointA[0] = myXcenter + (myRadius / Math.cos(myHalfAngle));
                                        myPointA[1] = myYcenter;
                                        // alert("myPointA: [" + myPointA[0] + ", " + myPointA[1] + "]");

                                        // myPointB
                                        myPointB = new Array();
                                        var segmentOA = myPointA[0] - myXcenter;
                                        myPointB[0] = myXcenter - (segmentOA * Math.cos(Math.PI - (2 * myHalfAngle)));
                                        myPointB[1] = myYcenter - (segmentOA * Math.sin(Math.PI - (2 * myHalfAngle)));
                                        // alert("myPointB: [" + myPointB[0] + ", " + myPointB[1] + "]");

                                        // myPointC
                                        myPointC = new Array();
                                        myPointC[0] = myXcenter;
                                        myPointC[1] = myYcenter;
                                        // alert("myPointC: [" + myPointC[0] + ", " + myPointC[1] + "]");


                                        // Draw the triangle
                                        myTriangle = app.activeWindow.activeSpread.polygons.add();
                                        var myPathPoints = new Array([myPointA[0], myPointA[1]],[myPointB[0], myPointB[1]], [myPointC[0], myPointC[1]]);
                                        myTriangle.paths.item(0).entirePath = myPathPoints;

                                        // Rotate the triangle
                                        // rotate([angle], [around], [consider current rotation], [rotate content as well], [consider parent rotation]);
                                        var myRotation = 90 - myAngleD;
                                        myRotation = myRotation - extraRotation;
                                        
                                        // Extra rotation required for the following slices
                                        extraRotation += myAngleD;

                                        var myProxy = [myXcenter, myYcenter];
                                        myTriangle.rotate(myRotation, myProxy, false, true, true);

                                        // Cut the slice out of the circle
                                        myTriangle.intersectPath(myNewCircles[i]);
                                        
                                        // Apply stroke and fill color characteristics
                                        myNewCircles[i].strokeColor = app.activeDocument.swatches.item(myStrokeColor);
                                        myNewCircles[i].strokeWeight = myStrokeWeight;
                                        myNewCircles[i].strokeAlignment = StrokeAlignment.centerAlignment;
                                        myNewCircles[i].endJoin = EndJoin.miterEndJoin;
                                        myNewCircles[i].miterLimit = Math.ceil(myStrokeWeight);
                                        myNewCircles[i].fillColor = app.activeDocument.swatches.item(myFillColor[sliceCounter]);
                                        }
                                        
                                        
                                        else if (myAngleD <= 180 && myAngleD > 90) {
                                        // 2 triangles required
                                        // TRIANGLE 1:
                                        var myAngleD_1 = 90;
                                        
                                        myHalfAngle_1 = (myAngleD_1 * DtoR) / 2;

                                        var myPointA_1, myPointB_1, myPointC;

                                        // myPointA_1
                                        myPointA_1 = new Array();
                                        myPointA_1[0] = myXcenter + (myRadius / Math.cos(myHalfAngle_1));
                                        myPointA_1[1] = myYcenter;
                                        // alert("myPointA_1: [" + myPointA_1[0] + ", " + myPointA_1[1] + "]");

                                        // myPointB_1
                                        myPointB_1 = new Array();
                                        var segmentOA = myPointA_1[0] - myXcenter;
                                        myPointB_1[0] = myXcenter - (segmentOA * Math.cos(Math.PI - (2 * myHalfAngle_1)));
                                        myPointB_1[1] = myYcenter - (segmentOA * Math.sin(Math.PI - (2 * myHalfAngle_1)));
                                        // alert("myPointB_1: [" + myPointB_1[0] + ", " + myPointB_1[1] + "]");

                                        // myPointC
                                        myPointC = new Array();
                                        myPointC[0] = myXcenter;
                                        myPointC[1] = myYcenter;
                                        // alert("myPointC: [" + myPointC[0] + ", " + myPointC[1] + "]");


                                        // Draw triangle 1
                                        myTriangle_1 = app.activeWindow.activeSpread.polygons.add();
                                        var myPathPoints = new Array([myPointA_1[0], myPointA_1[1]],[myPointB_1[0], myPointB_1[1]], [myPointC[0], myPointC[1]]);
                                        myTriangle_1.paths.item(0).entirePath = myPathPoints;
                                        
                                        // TRIANGLE 2:
                                        var myAngleD_2 = myAngleD - 90;
                                        
                                        myHalfAngle_2 = (myAngleD_2 * DtoR) / 2;

                                        var myPointA_2, myPointB_2, myPointC;

                                        // myPointA_2
                                        myPointA_2 = new Array();
                                        myPointA_2[0] = myXcenter + (myRadius / Math.cos(myHalfAngle_2));
                                        myPointA_2[1] = myYcenter;
                                        // alert("myPointA_2: [" + myPointA_2[0] + ", " + myPointA_2[1] + "]");

                                        // myPointB_2
                                        myPointB_2 = new Array();
                                        var segmentOA = myPointA_2[0] - myXcenter;
                                        myPointB_2[0] = myXcenter - (segmentOA * Math.cos(Math.PI - (2 * myHalfAngle_2)));
                                        myPointB_2[1] = myYcenter - (segmentOA * Math.sin(Math.PI - (2 * myHalfAngle_2)));
                                        // alert("myPointB_2: [" + myPointB_2[0] + ", " + myPointB_2[1] + "]");

                                        // myPointC
                                        myPointC = new Array();
                                        myPointC[0] = myXcenter;
                                        myPointC[1] = myYcenter;
                                        // alert("myPointC: [" + myPointC[0] + ", " + myPointC[1] + "]");


                                        // Draw triangle 2
                                        myTriangle_2 = app.activeWindow.activeSpread.polygons.add();
                                        var myPathPoints = new Array([myPointA_2[0], myPointA_2[1]],[myPointB_2[0], myPointB_2[1]], [myPointC[0], myPointC[1]]);
                                        myTriangle_2.paths.item(0).entirePath = myPathPoints;
                                        
                                        // Rotate triangle 2
                                        // rotate([angle], [around], [consider current rotation], [rotate content as well], [consider parent rotation]);
                                        myRotation = 90;
                                        var myProxy = [myXcenter, myYcenter];
                                        myTriangle_2.rotate(myRotation, myProxy, false, true, true);
                                        
                                        // Combine Triangle 1 with Triangle 2 to form a new polygon
                                        var myNewPolygon = myTriangle_1.addPath(myTriangle_2);
                                                                                
                                        // ============================

                                        // Rotate the new polygon
                                        // rotate([angle], [around], [consider current rotation], [rotate content as well], [consider parent rotation]);
                                        myRotation = - myAngleD_2;
                                        myRotation = myRotation - extraRotation;
                                        
                                        // Extra rotation required for the following slices
                                        extraRotation += myAngleD;

                                        var myProxy = [myXcenter, myYcenter];
                                        myNewPolygon.rotate(myRotation, myProxy, true, true);

                                        // Cut the slice out of the circle
                                        myNewPolygon.intersectPath(myNewCircles[i]);
                                        
                                        // Apply stroke and fill color characteristics
                                        myNewCircles[i].strokeColor = app.activeDocument.swatches.item(myStrokeColor);
                                        myNewCircles[i].strokeWeight = myStrokeWeight;
                                        myNewCircles[i].strokeAlignment = StrokeAlignment.centerAlignment;
                                        myNewCircles[i].endJoin = EndJoin.miterEndJoin;
                                        myNewCircles[i].miterLimit = Math.ceil(myStrokeWeight);
                                        myNewCircles[i].fillColor = app.activeDocument.swatches.item(myFillColor[sliceCounter]);
                                        }
                                        
                                        
                                        else if (myAngleD <= 270 && myAngleD > 180) {
                                        // 3 triangles required
                                        // TRIANGLE 1:
                                        var myAngleD_1 = 90;
                                        
                                        myHalfAngle_1 = (myAngleD_1 * DtoR) / 2;

                                        var myPointA_1, myPointB_1, myPointC;

                                        // myPointA_1
                                        myPointA_1 = new Array();
                                        myPointA_1[0] = myXcenter + (myRadius / Math.cos(myHalfAngle_1));
                                        myPointA_1[1] = myYcenter;
                                        // alert("myPointA_1: [" + myPointA_1[0] + ", " + myPointA_1[1] + "]");

                                        // myPointB_1
                                        myPointB_1 = new Array();
                                        var segmentOA = myPointA_1[0] - myXcenter;
                                        myPointB_1[0] = myXcenter - (segmentOA * Math.cos(Math.PI - (2 * myHalfAngle_1)));
                                        myPointB_1[1] = myYcenter - (segmentOA * Math.sin(Math.PI - (2 * myHalfAngle_1)));
                                        // alert("myPointB_1: [" + myPointB_1[0] + ", " + myPointB_1[1] + "]");

                                        // myPointC
                                        myPointC = new Array();
                                        myPointC[0] = myXcenter;
                                        myPointC[1] = myYcenter;
                                        // alert("myPointC: [" + myPointC[0] + ", " + myPointC[1] + "]");


                                        // Draw triangle 1
                                        myTriangle_1 = app.activeWindow.activeSpread.polygons.add();
                                        var myPathPoints = new Array([myPointA_1[0], myPointA_1[1]],[myPointB_1[0], myPointB_1[1]], [myPointC[0], myPointC[1]]);
                                        myTriangle_1.paths.item(0).entirePath = myPathPoints;
                                        
                                        
                                        // TRIANGLE 2:
                                        // Basicly a flipped copy of Triangle 1
                                        var myPointA_2, myPointB_2, myPointC;

                                        // myPointA_2
                                        myPointA_2 = new Array();
                                        myPointA_2[0] = myXcenter - (myRadius / Math.cos(myHalfAngle_1));
                                        myPointA_2[1] = myYcenter;
                                        // alert("myPointA_2: [" + myPointA_2[0] + ", " + myPointA_2[1] + "]");

                                        // myPointB_2
                                        myPointB_2 = new Array();
                                        var segmentOA = myPointA_1[0] - myXcenter;
                                        myPointB_2[0] = myPointB_1[0];
                                        myPointB_2[1] = myPointB_1[1];
                                        // alert("myPointB_2: [" + myPointB_2[0] + ", " + myPointB_2[1] + "]");

                                        // myPointC
                                        myPointC = new Array();
                                        myPointC[0] = myXcenter;
                                        myPointC[1] = myYcenter;
                                        // alert("myPointC: [" + myPointC[0] + ", " + myPointC[1] + "]");


                                        // Draw triangle 2
                                        myTriangle_2 = app.activeWindow.activeSpread.polygons.add();
                                        var myPathPoints = new Array([myPointA_2[0], myPointA_2[1]],[myPointB_2[0], myPointB_2[1]], [myPointC[0], myPointC[1]]);
                                        myTriangle_2.paths.item(0).entirePath = myPathPoints;
                                        
                                        
                                        // TRIANGLE 3:
                                        var myAngleD_3 = myAngleD - 180;
                                        
                                        myHalfAngle_3 = (myAngleD_3 * DtoR) / 2;

                                        var myPointA_3, myPointB_3, myPointC;

                                        // myPointA_3
                                        myPointA_3 = new Array();
                                        myPointA_3[0] = myXcenter + (myRadius / Math.cos(myHalfAngle_3));
                                        myPointA_3[1] = myYcenter;
                                        // alert("myPointA_3: [" + myPointA_3[0] + ", " + myPointA_3[1] + "]");

                                        // myPointB_3
                                        myPointB_3 = new Array();
                                        var segmentOA = myPointA_3[0] - myXcenter;
                                        myPointB_3[0] = myXcenter - (segmentOA * Math.cos(Math.PI - (2 * myHalfAngle_3)));
                                        myPointB_3[1] = myYcenter - (segmentOA * Math.sin(Math.PI - (2 * myHalfAngle_3)));
                                        // alert("myPointB_3: [" + myPointB_3[0] + ", " + myPointB_3[1] + "]");

                                        // myPointC
                                        myPointC = new Array();
                                        myPointC[0] = myXcenter;
                                        myPointC[1] = myYcenter;
                                        // alert("myPointC: [" + myPointC[0] + ", " + myPointC[1] + "]");


                                        // Draw triangle 3
                                        myTriangle_3 = app.activeWindow.activeSpread.polygons.add();
                                        var myPathPoints = new Array([myPointA_3[0], myPointA_3[1]],[myPointB_3[0], myPointB_3[1]], [myPointC[0], myPointC[1]]);
                                        myTriangle_3.paths.item(0).entirePath = myPathPoints;
                                        
                                        // Rotate triangle 3
                                        // rotate([angle], [around], [consider current rotation], [rotate content as well], [consider parent rotation]);
                                        myRotation = 180;
                                        var myProxy = [myXcenter, myYcenter];
                                        myTriangle_3.rotate(myRotation, myProxy, false, true, true);
                                        
                                        // Combine triangle 1, 2 and 3 to form a new polygon
                                        var myNewPolygon = myTriangle_1.addPath(myTriangle_2);
                                        myNewPolygon = myNewPolygon.addPath(myTriangle_3);
                                                                                
                                        // ============================

                                        // Rotate the new polygon
                                        // rotate([angle], [around], [consider current rotation], [rotate content as well], [consider parent rotation]);
                                        myRotation = - myAngleD_3 - 90;
                                        myRotation = myRotation - extraRotation;
                                        
                                        // Extra rotation required for the following slices
                                        extraRotation += myAngleD;

                                        var myProxy = [myXcenter, myYcenter];
                                        myNewPolygon.rotate(myRotation, myProxy, true, true);

                                        // Cut the slice out of the circle
                                        myNewPolygon.intersectPath(myNewCircles[i]);
                                        
                                        // Apply stroke and fill color characteristics
                                        myNewCircles[i].strokeColor = app.activeDocument.swatches.item(myStrokeColor);
                                        myNewCircles[i].strokeWeight = myStrokeWeight;
                                        myNewCircles[i].strokeAlignment = StrokeAlignment.centerAlignment;
                                        myNewCircles[i].endJoin = EndJoin.miterEndJoin;
                                        myNewCircles[i].miterLimit = Math.ceil(myStrokeWeight);
                                        myNewCircles[i].fillColor = app.activeDocument.swatches.item(myFillColor[sliceCounter]);
                                        }
                                        
                                        
                                        else if (myAngleD > 270) {
                                        // 4 triangles required
                                        // TRIANGLE 1:
                                        var myAngleD_1 = 90;
                                        
                                        myHalfAngle_1 = (myAngleD_1 * DtoR) / 2;

                                        var myPointA_1, myPointB_1, myPointC;

                                        // myPointA_1
                                        myPointA_1 = new Array();
                                        myPointA_1[0] = myXcenter + (myRadius / Math.cos(myHalfAngle_1));
                                        myPointA_1[1] = myYcenter;
                                        // alert("myPointA_1: [" + myPointA_1[0] + ", " + myPointA_1[1] + "]");

                                        // myPointB_1
                                        myPointB_1 = new Array();
                                        var segmentOA = myPointA_1[0] - myXcenter;
                                        myPointB_1[0] = myXcenter - (segmentOA * Math.cos(Math.PI - (2 * myHalfAngle_1)));
                                        myPointB_1[1] = myYcenter - (segmentOA * Math.sin(Math.PI - (2 * myHalfAngle_1)));
                                        // alert("myPointB_1: [" + myPointB_1[0] + ", " + myPointB_1[1] + "]");

                                        // myPointC
                                        myPointC = new Array();
                                        myPointC[0] = myXcenter;
                                        myPointC[1] = myYcenter;
                                        // alert("myPointC: [" + myPointC[0] + ", " + myPointC[1] + "]");


                                        // Draw triangle 1
                                        myTriangle_1 = app.activeWindow.activeSpread.polygons.add();
                                        var myPathPoints = new Array([myPointA_1[0], myPointA_1[1]],[myPointB_1[0], myPointB_1[1]], [myPointC[0], myPointC[1]]);
                                        myTriangle_1.paths.item(0).entirePath = myPathPoints;
                                        
                                        
                                        // TRIANGLE 2:
                                        // Basicly a flipped copy of Triangle 1
                                        var myPointA_2, myPointB_2, myPointC;

                                        // myPointA_2
                                        myPointA_2 = new Array();
                                        myPointA_2[0] = myXcenter - (myRadius / Math.cos(myHalfAngle_1));
                                        myPointA_2[1] = myYcenter;
                                        // alert("myPointA_2: [" + myPointA_2[0] + ", " + myPointA_2[1] + "]");

                                        // myPointB_2
                                        myPointB_2 = new Array();
                                        var segmentOA = myPointA_1[0] - myXcenter;
                                        myPointB_2[0] = myPointB_1[0];
                                        myPointB_2[1] = myPointB_1[1];
                                        // alert("myPointB_2: [" + myPointB_2[0] + ", " + myPointB_2[1] + "]");

                                        // myPointC
                                        myPointC = new Array();
                                        myPointC[0] = myXcenter;
                                        myPointC[1] = myYcenter;
                                        // alert("myPointC: [" + myPointC[0] + ", " + myPointC[1] + "]");


                                        // Draw triangle 2
                                        myTriangle_2 = app.activeWindow.activeSpread.polygons.add();
                                        var myPathPoints = new Array([myPointA_2[0], myPointA_2[1]],[myPointB_2[0], myPointB_2[1]], [myPointC[0], myPointC[1]]);
                                        myTriangle_2.paths.item(0).entirePath = myPathPoints;
                                        
                                        
                                        // TRIANGLE 3:
                                        // Basicly a flipped copy of Triangle 2
                                        var myPointA_3, myPointB_3, myPointC;

                                        // myPointA_3
                                        myPointA_3 = new Array();
                                        myPointA_3[0] = myPointA_2[0]
                                        myPointA_3[1] = myYcenter;
                                        // alert("myPointA_3: [" + myPointA_3[0] + ", " + myPointA_3[1] + "]");

                                        // myPointB_3
                                        myPointB_3 = new Array();
                                        var segmentOA = myPointA_1[0] - myXcenter;
                                        myPointB_3[0] = myPointB_1[0];
                                        myPointB_3[1] = myYcenter + (segmentOA * Math.sin(Math.PI - (2 * myHalfAngle_1)));;
                                        // alert("myPointB_3: [" + myPointB_3[0] + ", " + myPointB_3[1] + "]");

                                        // myPointC
                                        myPointC = new Array();
                                        myPointC[0] = myXcenter;
                                        myPointC[1] = myYcenter;
                                        // alert("myPointC: [" + myPointC[0] + ", " + myPointC[1] + "]");


                                        // Draw triangle 3
                                        myTriangle_3 = app.activeWindow.activeSpread.polygons.add();
                                        var myPathPoints = new Array([myPointA_3[0], myPointA_3[1]],[myPointB_3[0], myPointB_3[1]], [myPointC[0], myPointC[1]]);
                                        myTriangle_3.paths.item(0).entirePath = myPathPoints;
                                        
                                        
                                        // TRIANGLE 4:
                                        var myAngleD_4 = myAngleD - 270;
                                        
                                        myHalfAngle_4 = (myAngleD_4 * DtoR) / 2;

                                        var myPointA_4, myPointB_4, myPointC;

                                        // myPointA_4
                                        myPointA_4 = new Array();
                                        myPointA_4[0] = myXcenter + (myRadius / Math.cos(myHalfAngle_4));
                                        myPointA_4[1] = myYcenter;
                                        // alert("myPointA_4: [" + myPointA_4[0] + ", " + myPointA_4[1] + "]");

                                        // myPointB_4
                                        myPointB_4 = new Array();
                                        var segmentOA = myPointA_4[0] - myXcenter;
                                        myPointB_4[0] = myXcenter - (segmentOA * Math.cos(Math.PI - (2 * myHalfAngle_4)));
                                        myPointB_4[1] = myYcenter - (segmentOA * Math.sin(Math.PI - (2 * myHalfAngle_4)));
                                        // alert("myPointB_4: [" + myPointB_4[0] + ", " + myPointB_4[1] + "]");

                                        // myPointC
                                        myPointC = new Array();
                                        myPointC[0] = myXcenter;
                                        myPointC[1] = myYcenter;
                                        // alert("myPointC: [" + myPointC[0] + ", " + myPointC[1] + "]");


                                        // Draw triangle 4
                                        myTriangle_4 = app.activeWindow.activeSpread.polygons.add();
                                        var myPathPoints = new Array([myPointA_4[0], myPointA_4[1]],[myPointB_4[0], myPointB_4[1]], [myPointC[0], myPointC[1]]);
                                        myTriangle_4.paths.item(0).entirePath = myPathPoints;
                                        
                                        // Rotate triangle 4
                                        // rotate([angle], [around], [consider current rotation], [rotate content as well], [consider parent rotation]);
                                        myRotation = 270;
                                        var myProxy = [myXcenter, myYcenter];
                                        myTriangle_4.rotate(myRotation, myProxy, false, true, true);
                                        
                                        // Combine triangle 1, 2, 3 and 4 to form a new polygon
                                        var myNewPolygon = myTriangle_1.addPath(myTriangle_2);
                                            myNewPolygon = myNewPolygon.addPath(myTriangle_3);
                                            myNewPolygon = myNewPolygon.addPath(myTriangle_4);
                                                                                
                                        // ============================

                                        // Rotate the new polygon
                                        // rotate([angle], [around], [consider current rotation], [rotate content as well], [consider parent rotation]);
                                        myRotation = - myAngleD_4 - 180;
                                        myRotation = myRotation - extraRotation;
                                        
                                        // Extra rotation required for the following slices
                                        extraRotation += myAngleD;

                                        var myProxy = [myXcenter, myYcenter];
                                        myNewPolygon.rotate(myRotation, myProxy, true, true);

                                        // Cut the slice out of the circle
                                        myNewPolygon.intersectPath(myNewCircles[i]);
                                        
                                        // Apply stroke and fill color characteristics
                                        myNewCircles[i].strokeColor = app.activeDocument.swatches.item(myStrokeColor);
                                        myNewCircles[i].strokeWeight = myStrokeWeight;
                                        myNewCircles[i].strokeAlignment = StrokeAlignment.centerAlignment;
                                        myNewCircles[i].endJoin = EndJoin.miterEndJoin;
                                        myNewCircles[i].miterLimit = Math.ceil(myStrokeWeight);
                                        myNewCircles[i].fillColor = app.activeDocument.swatches.item(myFillColor[sliceCounter]);
                                        }
                                }

                        // Delete the original circle
                        myCircle.remove();
		}
	}
}
// set scriptPreferences.versions to original of actual InDesign-Version (as for scriptstart)
app.scriptPreferences.version = myActualScriptPreferencesVersion;

// =========================================================================

function err(e){
	alert(e);

// Include the following at all possible exits from your script
// or arrange things so the script only ever exits one way
// RESTORE MEASUREMENTS TO WHAT THEY WERE
app.documents[0].viewPreferences.horizontalMeasurementUnits = userHoriz;
app.documents[0].viewPreferences.verticalMeasurementUnits = userVert;

	exit();
}

// =========================================================================

function myDefineFillColor(mySliceFillColorName){
        var mySliceFillColor;
        var myDocument = app.activeDocument;
        
        // Create the fill color swatch if it does not already exist.
        mySliceFillColor = myDocument.swatches.item(mySliceFillColorName);
        try{
                mySliceFillColor.name;
        }
        catch (myError){
        var mySliceFillColor = myDocument.colors.add();
	mySliceFillColor.colorValue = [25,25,25,25];
	mySliceFillColor.name = mySliceFillColorName;
        
        return mySliceFillColor.name;
        }
}

// =========================================================================

// Include the following at all possible exits from your script
// or arrange things so the script only ever exits one way
// RESTORE MEASUREMENTS TO WHAT THEY WERE
app.documents[0].viewPreferences.horizontalMeasurementUnits = userHoriz;
app.documents[0].viewPreferences.verticalMeasurementUnits = userVert;

// =========================================================================

/*
PieGraph.js
Copyright (C) 2005  Mariusz Sobolewski
e-mail: mariusz@sobolewski.biz
www.sobolewski.biz

This script is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This script is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/